package com.coob.aframe.base;

import com.alibaba.fastjson.JSONObject;

import java.util.HashMap;
import java.util.Map;

/**
 * 返回数据
 *
 * @author yuandong
 * @date 2018年11月18日 下午13:13:23
 */
public class R extends HashMap<String, Object> {

    private static final long serialVersionUID = 1L;

    public R() {
        put("code", 0);
    }

    public static R error() {
        return error(500, "系统发生错误，请重试或联系管理员解决！");
    }

    public static R error(String msg) {
        return error(500, msg);
    }

    public static JSONObject errorJson(String msg) {
        JSONObject obj = new JSONObject();
        obj.put("code", false);
        obj.put("msg", msg);
        return obj;
    }

    public static R error(int code, String msg) {
        R r = new R();
        r.put("code", code);
        r.put("msg", msg);
        return r;
    }

    public static R ok(String msg) {
        R r = new R();
        r.put("msg", msg);
        return r;
    }

    public static JSONObject okJson() {
        JSONObject result = new JSONObject();
        result.put("code", true);
        return result;
    }

    public static JSONObject okJson(String msg) {
        JSONObject obj = new JSONObject();
        obj.put("code", true);
        obj.put("msg", msg);
        return obj;
    }

    public static JSONObject okJson(String key, Object value) {
        JSONObject obj = new JSONObject();
        obj.put("code", true);
        obj.put(key, value);
        return obj;
    }

    public static R ok(Map<String, Object> map) {
        R r = new R();
        r.putAll(map);
        return r;
    }

    public static R ok() {
        return new R();
    }

    @Override
    public R put(String key, Object value) {
        super.put(key, value);
        return this;
    }
}
