package com.coob.aframe.fileCreate;


/**
 * 根据数据库表生成相关文件主程序
 *  配置db-config.xml后运行 main()函数
 */
public class AMain {
	
	public void execute(){
		String curPath = AMain.class.getResource("").toString().substring(6);
		System.out.println("curPath::"+curPath);

		//设置项目所在的地址，到main目录，并以“/”结束
		String projPath = "D:/公司项目/3707-潍坊/83-寿光/scjg-市场监管平台-20240707/space/mb/src/main/";
		System.out.println("ProjPath::"+projPath);
		
		String configPath = projPath+"java/com/coob/aframe/fileCreate/db-config.xml";
		System.out.println("configPath::"+configPath);
		
		String javaBasePath = projPath + "java/";
		System.out.println("configPath::"+javaBasePath);
		
		String jspBasePath = projPath + "webapp/";
		System.out.println("jspBasePath::"+jspBasePath);
		
		//获取配置内容
		ConfigBean configBean = ConfigUtil.getConfigInfo(configPath);
		
		//获取数据库字段等信息
		ConnDatabase conn = new ConnDatabase();
		conn.getTableInfo(configBean);
		
		System.out.println("\r\n >>>>>>>>>>>>> 开始创建文件:");
		for( ConfigTable table : configBean.tableList){
			System.out.println(">>>>>> "+ table.tableName +" 表:");
			
			if( table.sqlFlag) {
				if( configBean.dataBaseType.equals("oracle")){
					CreateMappingOracle.create(projPath + table.defaultMappingPath, table);
				} else {
					CreateMapping.create(projPath + table.defaultMappingPath, table);
				}
			}
			if( table.domainFlag ) CreateDomain.create(javaBasePath, table, configBean);
			if( table.daoFlag ) CreateDao.create(javaBasePath, table, configBean);
			if( table.serviceFlag ) CreateService.create(javaBasePath, table, configBean);
			if( table.actionFlag ) CreateController.create(javaBasePath, table, configBean);
			
			if( table.listFlag ) CreateListJsp.create(jspBasePath, table, configBean);
			if( table.addFlag ) CreateAddJsp.create(jspBasePath, table, configBean);
			if( table.editFlag ) CreateEditJsp.create(jspBasePath, table, configBean);
			if( table.viewFlag ) CreateViewJsp.create(jspBasePath, table, configBean);
		}
	}
	
	public static void main(String[] args) {
		new AMain().execute();
	}
	
	
}
