package com.coob.aframe.fileCreate;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.RandomAccessFile;
import java.util.List;
import java.util.Random;

import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;

/**
 * 创建文件工具
 * @author Administrator
 *
 */
public class CUtil {
	
	/**
	 * 创建文件
	 * @param path 路径
	 * @param fName 文件名
	 * @param pros 后缀
	 * @return
	 */
	public static File createFile(String path,String fName,String pros){
		File file = null;
		try{
			File dir = new File(path);
			if( !dir.exists()){
				dir.mkdirs();
			}
			
			String _fname = fName;
			for(int i=0; i<99; i++){
				if( i > 0) _fname = fName + i; 
				file = new File(path+"/"+_fname+"."+pros);
				if( !file.exists() ){
					file.createNewFile();
					break;
				}else {
					if( !file.isFile()){
						file.createNewFile();
						break;
					}
				}
			}
		}catch(Exception e){
			e.printStackTrace();
		}
		return file;
	}
	
	/**
	 * 
	 * @return
	 */
	public static String getUID(){
		StringBuffer uid = new StringBuffer();
		Random random = new Random();
		while(true){
			uid.append(Math.abs(random.nextInt()));
			if( uid.length()>=18 ) break;
		}
		uid = new StringBuffer(uid.substring(0,17));
		uid.append("L");
		return uid.toString();
	}
	
	/**
	 * 名字处理(类名、字段名)
	 * @param name
	 * @param sxx 1大小写  2首字母大写 3首字母小写
	 * @return
	 */
	public static String reName(String name,int sxx){
		StringBuffer str = new StringBuffer();
		//去掉_
		
		String[] n = name.toLowerCase().split("_");
		if( sxx == 2){
			str.append((char)(n[0].charAt(0)-32));
		}else {
			str.append((char)(n[0].charAt(0)));
		}
		str.append(n[0].substring(1));
		for( int i=1;i<n.length;i++ ){
			str.append((char)(n[i].charAt(0)-32));
			str.append(n[i].substring(1));
		}
		return str.toString();
	}
	
	/**
	 * 首字母小写
	 * @param str
	 * @return
	 */
	public static String szmXx(String str){
		return (char)(str.charAt(0)+32)+str.substring(1);
	}
	
	/**
	 * 写入XML
	 * @param document
	 * @param filename
	 */
	public static void writeXML(Document document,String filename,String doctype_system,String doctype_public) {
		try {
			document.normalize();
			
			// 将document中的内容写入文件中 
			TransformerFactory tFactory = TransformerFactory.newInstance();
			Transformer transformer = tFactory.newTransformer();
			transformer.setOutputProperty(OutputKeys.ENCODING, "UTF-8");
			transformer.setOutputProperty(OutputKeys.INDENT, "yes");
			if( doctype_system != null )
			transformer.setOutputProperty(OutputKeys.DOCTYPE_SYSTEM, doctype_system);
			if( doctype_public != null )
			transformer.setOutputProperty(OutputKeys.DOCTYPE_PUBLIC, doctype_public);
			
	         //编码
			DOMSource source = new DOMSource(document);
			PrintWriter pw = new PrintWriter(new FileOutputStream(filename));
			StreamResult result = new StreamResult(pw);
			transformer.transform(source, result);
		} catch (Exception e) {
	    	 e.printStackTrace();
		}
	}
	
	public static void writeContent(String fileName, long length, List<String> contents) {  
		RandomAccessFile randomFile = null;  
		try {
			// 打开一个随机访问文件流，按读写方式     
			randomFile = new RandomAccessFile(fileName, "rw");     
			// 将写文件指针移到追加位置。
			randomFile.seek(length); 
			for( String str : contents){
				randomFile.writeBytes(str+"\r\n");
			}
		} catch (IOException e) {  
			e.printStackTrace();
		} finally{
			if(randomFile != null){  
				try {  
					randomFile.close();  
				} catch (IOException e) {  
					e.printStackTrace();  
				}  
			}  
		}  
	} 
}
	

