package com.coob.aframe.fileCreate;

import java.util.HashMap;
import java.util.Map;

/**
 * 数据库字段处理
 */
public class ColumnBean {
	private String colName;		//USERNAME	数据字段名 默认全大写
	private String colType;		//VARCHAR 字段类型
	private String colComment;	//字段注解
	private Integer colLen;
	
	private String beanName;	//userinfo  实体类属性  默认全小写
	private String dxName;		//首字母大写
	private String beanType;
	private Integer beanLen;	
	
	private static Map<String,String> colTypeMap = new HashMap<String,String>();
	private static Map<String,String> beanTypeMap = new HashMap<String,String>();
	static{
		colTypeMap.put("TINYINT",   "INTEGER");
		colTypeMap.put("SMALLINT",  "INTEGER");
		colTypeMap.put("MEDIUMINT", "INTEGER");
		colTypeMap.put("INT",       "INTEGER");
		colTypeMap.put("TINYINT",   "INTEGER");
		colTypeMap.put("BIGINT",    "INTEGER");
		colTypeMap.put("BIT",       "INTEGER");
		colTypeMap.put("REAL",      "");
		
		colTypeMap.put("DOUBLE", "DOUBLE");
		colTypeMap.put("FLOAT", "FLOAT");
		colTypeMap.put("DECIMAL", "DECIMAL");
		
		colTypeMap.put("CHAR", "CHAR");			//String
		colTypeMap.put("VARCHAR", "VARCHAR");
		colTypeMap.put("VARCHAR2", "VARCHAR");
		
		colTypeMap.put("DATE", "TIMESTAMP");
		colTypeMap.put("TIME", "TIMESTAMP");
		colTypeMap.put("DATETIME", "TIMESTAMP");
		colTypeMap.put("TIMESTAMP", "TIMESTAMP");
		
		colTypeMap.put("TINYTEXT", "VARCHAR");
		colTypeMap.put("TEXT", "VARCHAR");
		colTypeMap.put("LONGTEXT", "VARCHAR");
		
		colTypeMap.put("NUMBER", "DECIMAL");
		colTypeMap.put("NVARCHAR2", "VARCHAR");
		colTypeMap.put("CLOB", "VARCHAR");
		colTypeMap.put("BLOB", "VARCHAR");
		
		
		beanTypeMap.put("INT", "Integer");
		beanTypeMap.put("BIT", "Integer");
		beanTypeMap.put("TINYINT", "Integer");
		beanTypeMap.put("BIGINT", "Integer");
		beanTypeMap.put("INTEGER", "Integer");
		beanTypeMap.put("NUMBER", "BigDecimal");
		beanTypeMap.put("VARCHAR","String");
		beanTypeMap.put("CHAR","String");
		beanTypeMap.put("DATE","Date");
		beanTypeMap.put("DATETIME","Date");
		beanTypeMap.put("TIMESTAMP","Date");
		beanTypeMap.put("DECIMAL", "BigDecimal");
		beanTypeMap.put("TEXT", "String");
		beanTypeMap.put("FLOAT", "Double");
		beanTypeMap.put("NVARCHAR2", "String");
		beanTypeMap.put("CLOB", "String");
		beanTypeMap.put("BLOB", "String");
		beanTypeMap.put("DOUBLE", "Double");
	}
	
	
	public ColumnBean(){}
	
	
	/**
	 * 由数据库查询库表字段时初始化
	 * @param colName
	 * @param colType
	 */
	public ColumnBean(String colName,String colType,String colcomment){
		this.colName = colName;
		this.beanName = CUtil.reName(colName, 1);
		this.dxName = CUtil.reName(colName, 2);
		
		if( this.colName != null ) this.colLen = this.colName.length();
		else this.colLen = 0;
		
		if( this.beanName != null ) this.beanLen = this.beanName.length();
		else this.beanLen = 0;
		
		this.colType = colTypeMap.get(colType);
		if( this.colType == null ) this.colType = colType;
		this.beanType = beanTypeMap.get(colType);
		if( colcomment != null && colcomment.length() > 0 ) {
			this.colComment =colcomment;
		}
		System.out.println(colName+" : "+beanName+" : "+ dxName+" >  "+colType+" > "+beanType);
	}
	
	
	public String getColName() {
		return colName;
	}
	
	public void setColName(String colName) {
		this.colName = colName;
	}
	
	public String getColType() {
		return colType;
	}
	
	public void setColType(String colType) {
		this.colType = colTypeMap.get(colType);
		if( this.colType == null ) this.colType = colType;
	}
	
	public String getDxName() {
		return dxName;
	}
	
	public void setDxName(String dxName) {
		this.dxName = dxName;
	}
	
	public String getBeanName() {
		return beanName;
	}
	
	public void setBeanName(String beanName) {
		this.beanName = beanName;
	}
	
	public String getBeanType() {
		return beanType;
	}
	
	public void setBeanType(String beanType) {
		this.beanType = beanType;
	}

	public String getColComment() {
		return colComment;
	}

	public void setColComment(String colComment) {
		this.colComment = colComment;
	}

	public Integer getColLen() {
		return colLen;
	}

	public void setColLen(Integer colLen) {
		this.colLen = colLen;
	}

	public Integer getBeanLen() {
		return beanLen;
	}

	public void setBeanLen(Integer beanLen) {
		this.beanLen = beanLen;
	}
}
