package com.coob.aframe.fileCreate;

import java.util.ArrayList;
import java.util.List;

/**
 * 配置文件内容
 */
public class ConfigBean {
	
	public String dataBaseType;	//数据库类型
	public String driveClass;	//驱动
	public String dataBaseUrl;	//连接
	public String username;		//用户名
	public String password;		//密码
	
	public String baseBeanName;
	public String baseAction;
	public String baseActionName;
	public String rtnEntity;
	public String rtnEntityName;
	public String pageBeanName;
	
	public List<ConfigTable> tableList;

	public ConfigBean(){
		this.tableList = new ArrayList<ConfigTable>();
	}
	
	public void addTable(ConfigTable table){
		table.setDefault();
		this.tableList.add(table);
	}
	
	public boolean checkSource(){
		if( dataBaseType == null || dataBaseType.length()== 0 ){
			System.out.println("ERR：没有指定数据库类型 .");
			return false;
		}
		if( driveClass == null || driveClass.length()== 0 ){
			System.out.println("ERR：没有配置驱动字符串.");
			return false;
		}
		if( dataBaseUrl == null || dataBaseUrl.length()== 0 ){
			System.out.println("ERR：没有配置数据库URL.");
			return false;
		}
		if( username == null || username.length()== 0 ){
			System.out.println("ERR：没有配置数据库用户名.");
			return false;
		}
		if( password == null || password.length()== 0 ){
			System.out.println("ERR：没有没有配置数据库密码.");
			return false;
		}
		
		return true;
	}
	
	public boolean checkBase(){
		if( baseAction == null || baseAction.length()== 0 ){
			System.out.println("ERR：没有指定基础Action类 .");
			return false;
		}
		return true;
	}
	
	public String toString(){
		System.out.println(">>> 配置内容：");
		System.out.println("************* 数据库配置  ************ ");
		System.out.println(" >> 数据库类型："+dataBaseType);
		System.out.println(" >> 数据库驱动："+driveClass);
		System.out.println(" >> 数据库连接："+dataBaseUrl);
		System.out.println(" >> 用户名："+username);
		System.out.println(" >> 密码："+password);
		System.out.println("************* 基础类配置  ************ ");
		System.out.println(" >> BaseAction："+baseAction);
		System.out.println(" >> RtnEntity："+rtnEntity);
		System.out.println("************* 数据库表配置  ************ ");
		for(ConfigTable table : tableList ){
			System.out.println(">>>>"+table.tableName+" 表：");
			System.out.println("  Mapping文件路径："+table.defaultMappingPath);
			System.out.println("  JavaBean名称："+table.javaEntity);
			System.out.println("  Java文件路径："+table.defaultJavaPath);
			System.out.println("  Jsp 路径："+table.defaultJspPath);
			System.out.println(" >> 文件配置： ");
			System.out.println("  Sql文件："+table.sqlPath+"/"+table.sqlName+" : "+table.serviceFlag);
			System.out.println("  Domain文件："+table.domainPath+"."+table.domainName+" : "+table.domainFlag);
			System.out.println("  Dao文件："+table.daoPath+"."+table.daoName+" : "+table.daoFlag);
			System.out.println("  Service文件："+table.servicePath+"."+table.serviceName+" : "+table.serviceFlag);
			System.out.println("  Action文件："+table.actionPath+"."+table.actionName+" : "+table.actionFlag);
			System.out.println("  List文件："+table.listPath+"/"+table.listName+" : "+table.listFlag);
			System.out.println("  Add文件："+table.addPath+"/"+table.addName+" : "+table.addFlag);
			System.out.println("  Edit文件："+table.editPath+"/"+table.editName+" : "+table.editFlag);
			System.out.println("  View文件："+table.viewPath+"/"+table.viewName+" : "+table.viewFlag);
			
		}
		
		System.out.println("*************  OVER  ************ ");
		return null;
	}
}
