package com.coob.aframe.fileCreate;

import com.coob.zhfg.system.domain.User;
import com.github.pagehelper.PageInfo;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;

/**
 * 生成通用Controller文件
 */
public class CreateController {
	
	/**
	 * 创建通用Controller文件
	 * createAction
	 * @param table
	 */
	public static void create(String basePath, ConfigTable table, ConfigBean config){

		String idType = "Integer";
		for( ColumnBean col : table.columnList ){
			if( "id".equals(col.getColName())){
				idType = col.getBeanType();
				break;
			}
		}

		String p = basePath+table.actionPath.replace(".", "/");
		File file = CUtil.createFile(p, table.actionName, "java");
		
		try{ 
			BufferedWriter writer = new BufferedWriter(new FileWriter(file));     
			writer.write("package "+table.actionPath+";\r\n"); 
			writer.write("\r\n");

			if( config.baseAction != null && config.baseAction.length()> 0 ) {
				writer.write("import " + config.baseAction + ";\r\n");
			}
			writer.write("import "+table.domainPath+"."+table.domainName+";\r\n");
			writer.write("import "+table.servicePath+"."+table.serviceName+";\r\n");
			writer.write("\r\n");

			writer.write("import com.github.pagehelper.PageInfo;\r\n");
			writer.write("import javax.annotation.Resource;\r\n");
			writer.write("import org.springframework.stereotype.Controller;\r\n");
			writer.write("import org.springframework.web.bind.annotation.RequestMapping;\r\n");
			writer.write("import org.springframework.web.bind.annotation.RequestMethod;\r\n");
			writer.write("import org.springframework.ui.Model;\r\n");
			writer.write("import java.util.List;\r\n");
			writer.write("import java.util.Map;\r\n");
			writer.write("import java.util.HashMap;\r\n");
			writer.write("\r\n");

			writer.write("@RequestMapping(\""+table.action+"\")\r\n");
			writer.write("@Controller\r\n");
			writer.write("public class "+table.actionName+" extends "+config.baseActionName+" {\r\n");
			writer.write("\t@Resource\r\n");
			writer.write("\tprivate "+table.serviceName+" "+table.serviceNamexx+";\r\n");
			writer.write("\r\n\r\n");

			writer.write("\t/**\r\n");
			writer.write("\t * 查询列表\r\n");
			writer.write("\t * @param model\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\t@RequestMapping(value = \"/doList\", method = {RequestMethod.GET, RequestMethod.POST})\r\n");
			writer.write("\tpublic String doList(Model model) {\r\n");
			writer.write("\t\tMap<String,Object> params = new HashMap<String,Object>();\r\n");
			writer.write("\r\n");
			writer.write("\t\tthis.setParamToSession(params);\r\n");
			writer.write("\r\n");
			writer.write("\t\tsuper.offsetPage(1);\r\n");
			writer.write("\t\tList<"+table.domainName+"> list = this."+table.serviceNamexx+".selectByParams(params);\r\n");
			writer.write("\t\tPageInfo<"+table.domainName+"> pageInfo = new PageInfo<>(list);\r\n");
			writer.write("\r\n");
			writer.write("\t\tmodel.addAttribute(\"pageInfo\", pageInfo);\r\n");
			writer.write("\r\n");
			writer.write("\t\treturn \""+table.defaultJspPath+"/list\";\r\n");
			writer.write("\t}\r\n");
			writer.write("\r\n");
			writer.write("\r\n");

			writer.write("\t/**\r\n");
			writer.write("\t * 分页\r\n");
			writer.write("\t * @param pageNum\r\n");
			writer.write("\t * @param model\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\t@RequestMapping(value = \"/doPage\")\r\n");
			writer.write("\tpublic String doPage(Integer pageNum, Model model) {\r\n");
			writer.write("\t\tMap<String,Object> params = this.getSessionParam();\r\n");
			writer.write("\r\n");
			writer.write("\t\tsuper.offsetPage(pageNum);\r\n");
			writer.write("\t\tList<"+table.domainName+"> list = this."+table.serviceNamexx+".selectByParams(params);\r\n");
			writer.write("\t\tPageInfo<"+table.domainName+"> pageInfo = new PageInfo<>(list);\r\n");
			writer.write("\r\n");
			writer.write("\t\tmodel.addAttribute(\"pageInfo\", pageInfo);\r\n");
			writer.write("\r\n");
			writer.write("\t\treturn \""+table.defaultJspPath+"/list\";\r\n");
			writer.write("\t}\r\n");
			writer.write("\r\n");
			writer.write("\r\n");

			writer.write("\t/**\r\n");
			writer.write("\t * 进入新增页面\r\n");
			writer.write("\t * @param model\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\t@RequestMapping(value = \"/toAdd\")\r\n");
			writer.write("\tpublic String toAdd(Model model) {\r\n");
			writer.write("\t\t"+table.domainName+" "+table.domainNamexx+" = new "+table.domainName+"();\r\n");
			writer.write("\t\tmodel.addAttribute(\""+table.domainNamexx+"\", "+table.domainNamexx+");\r\n");
			writer.write("\r\n");
			writer.write("\t\treturn \""+table.defaultJspPath+"/add\";\r\n");
			writer.write("\t}\r\n");
			writer.write("\r\n");
			writer.write("\r\n");

			writer.write("\t/**\r\n");
			writer.write("\t * 保存新增信息\r\n");
			writer.write("\t * @param "+table.domainNamexx+"\r\n");
			writer.write("\t * @param model\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\t@RequestMapping(value = \"/doAdd\")\r\n");
			writer.write("\tpublic String doAdd("+table.domainName+" "+table.domainNamexx+", Model model){\r\n");
			writer.write("\t\tint flag = this."+table.serviceNamexx+".insert("+table.domainNamexx+");\r\n");
			writer.write("\r\n");
			writer.write("\t\tthis.alert(\"信息保存成功\");\r\n");
			writer.write("\r\n");
			writer.write("\t\treturn \"redirect:doList\";\r\n");
			writer.write("\t}\r\n");
			writer.write("\r\n");
			writer.write("\r\n");

			writer.write("\t/**\r\n");
			writer.write("\t * 进入修改页面\r\n");
			writer.write("\t * @param id\r\n");
			writer.write("\t * @param model\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\t@RequestMapping(value = \"/toEdit\")\r\n");
			writer.write("\tpublic String toEdit("+idType+" id, Model model) {\r\n");
			writer.write("\r\n");
			writer.write("\t\t" + table.domainName + " " + table.domainNamexx + " = this." + table.serviceNamexx + ".selectById(id);\r\n");
			writer.write("\t\tmodel.addAttribute(\""+table.domainNamexx+"\", "+table.domainNamexx+");\r\n");
			writer.write("\r\n");
			writer.write("\t\treturn \""+table.defaultJspPath+"/edit\";\r\n");
			writer.write("\t}\r\n");
			writer.write("\r\n");
			writer.write("\r\n");

			writer.write("\t/**\r\n");
			writer.write("\t * 保存修改信息\r\n");
			writer.write("\t * @param "+table.domainNamexx+"\r\n");
			writer.write("\t * @param model\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\t@RequestMapping(value = \"/doEdit\")\r\n");
			writer.write("\tpublic String doEdit("+table.domainName+" "+table.domainNamexx+", Model model) {\r\n");
			writer.write("\t\tint flag = this."+table.serviceNamexx+".update("+table.domainNamexx+");\r\n");
			writer.write("\t\tthis.alert(\"信息保存成功\");\r\n");
			writer.write("\r\n");
			writer.write("\t\treturn \""+table.defaultJspPath+"/edit\";\r\n");
			writer.write("\t}\r\n");
			writer.write("\r\n");

			writer.write("\t/**\r\n");
			writer.write("\t * 删除信息\r\n");
			writer.write("\t * @param id\r\n");
			writer.write("\t * @param model\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\t@RequestMapping(value = \"/doDel\")\r\n");
			writer.write("\tpublic String doDel("+idType+" id, Model model) {\r\n");
			writer.write("\t\tint flag = this."+table.serviceNamexx+".deleteById(id);\r\n");
			writer.write("\t\tthis.alert(\"信息删除成功\");\r\n");
			writer.write("\r\n");
			writer.write("\t\treturn \"redirect:doPage\";\r\n");
			writer.write("\t}\r\n");
			writer.write("\r\n");

			writer.write("\t/**\r\n");
			writer.write("\t * 查看详细信息\r\n");
			writer.write("\t * @param id\r\n");
			writer.write("\t * @param model\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\t@RequestMapping(value = \"/toView\")\r\n");
			writer.write("\tpublic String toView("+idType+" id, Model model) {\r\n");
			writer.write("\t\t" + table.domainName + " " + table.domainNamexx + " = this." + table.serviceNamexx + ".selectById(id);\r\n");
			writer.write("\t\tmodel.addAttribute(\""+table.domainNamexx+"\", "+table.domainNamexx+");\r\n");
			writer.write("\r\n");
			writer.write("\t\treturn \""+table.defaultJspPath+"/view\";\r\n");
			writer.write("\t}\r\n");
			writer.write("\r\n");
			

			writer.write("\r\n");
			writer.write("}\r\n");
			writer.close();
			
			System.out.println(table.actionPath+"."+table.actionName+" 创建成功...");
		}catch(Exception e){
			e.printStackTrace();
		}
	}
}
