package com.coob.aframe.fileCreate;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;

public class CreateDao {
	
	public static void create(String projPath, ConfigTable table, ConfigBean config){
		createIDao(projPath, table);
	}
	
	/**
	 * 创建Dao接口 
	 * @param table
	 */
	private static void createIDao(String basePath, ConfigTable table){
		String classpath = table.daoPath;
		
		String idType = "Integer";
		for( ColumnBean col : table.columnList ){
			if( "id".equals(col.getColName())){
				idType = col.getBeanType();
				break;
			}
		}

		String p = basePath + classpath.replace(".", "/");
		String daoName = table.daoName;
		File file = CUtil.createFile(p, daoName, "java");

		try{ 
			BufferedWriter writer = new BufferedWriter(new FileWriter(file));     
			writer.write("package "+classpath+";\r\n"); 
			writer.write("\r\n");
			writer.write("import java.util.List;\r\n");
			writer.write("import java.util.Map;\r\n");
			writer.write("\r\n");
			writer.write("import "+table.domainPath+"."+table.domainName+";\r\n");
			writer.write("\r\n");

			writer.write("public interface "+daoName+" {\r\n");
			writer.write("\r\n");
			
			writer.write("\t/**\r\n");
			writer.write("\t * 新增\r\n");
			writer.write("\t * @param "+table.domainNamexx+"\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\tint insert("+table.domainName+" "+table.domainNamexx+");\r\n");
			writer.write("\r\n");
			
			writer.write("\t/**\r\n");
			writer.write("\t * 修改\r\n");
			writer.write("\t * @param "+table.domainNamexx+"\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\tint update("+table.domainName+" "+table.domainNamexx+");\r\n");
			writer.write("\r\n");
			
			writer.write("\t/**\r\n");
			writer.write("\t * 逻辑删除\r\n");
			writer.write("\t * @param id\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\tint deleteById("+idType+" id);\r\n");
			writer.write("\r\n");
			
			writer.write("\t/**\r\n");
			writer.write("\t * 物理删除\r\n");
			writer.write("\t * @param id\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\tint physicalDeleteById("+idType+" id);\r\n");
			writer.write("\r\n");
			
			writer.write("\t/**\r\n");
			writer.write("\t * 根据id查询信息\r\n");
			writer.write("\t * @param id\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\t"+table.domainName+" selectById("+idType+" id);\r\n");
			writer.write("\r\n");

			writer.write("\t/**\r\n");
			writer.write("\t * 条件查询列表\r\n");
			writer.write("\t * @param params\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\tList<"+table.domainName+"> selectByParams(Map<String, Object> params);\r\n");
			writer.write("\r\n");
			writer.write("}\r\n");

			writer.close();
			
			System.out.println(classpath+"."+daoName+" 创建成功...");
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
}
