package com.coob.aframe.fileCreate;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.List;

/**
 * 创建数据库表对应的Bean类
 */
public class CreateDomain {

	/**
	 * 创建 domian Bean
	 * @param basePath
	 * @param table
	 * @param configBean
	 */
	public static void create(String basePath, ConfigTable table, ConfigBean configBean ){
		String beanFileName = null;

		List<ColumnBean> colList = table.columnList;
		String classpath = table.domainPath;
		beanFileName = table.domainName;
		
		String p = basePath + classpath.replace(".", "/");
		File file = CUtil.createFile(p, beanFileName, "java");
		
		try{ 
			BufferedWriter writer = new BufferedWriter(new FileWriter(file));     
			writer.write("package "+classpath+";\r\n"); 
			writer.write("\r\n");

			if( table.columnHasDate ) {
				writer.write("import java.util.Date;\r\n");
			}
			if( table.columnHasDecimal ){
				writer.write("import java.math.BigDecimal;\r\n");
			}

			writer.write("import lombok.Data;\r\n");
			writer.write("import java.io.Serializable;\r\n");
			
			writer.write("\r\n");

			writer.write("@Data\r\n");
			writer.write("public class "+beanFileName+" implements Serializable {\r\n");
			writer.write("\tprivate static final long serialVersionUID = 1L;\r\n");
			writer.write("\r\n");
			for( ColumnBean col : colList ){
				writer.write("\tprivate "+col.getBeanType()+" "+col.getBeanName()+";\t//");
				if( col.getColComment() != null ){
					writer.write(col.getColComment());
				}
				writer.write("\r\n");
			}
			writer.write("\r\n");

			writer.write("}\r\n\r\n");
			writer.close();
			System.out.println(classpath+"."+file.getName()+" 创建成功...");
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
}
