package com.coob.aframe.fileCreate;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.List;

public class CreateListJsp {
	
	public static void create(String jspBasePath, ConfigTable table, ConfigBean configBean){
		String path = jspBasePath+"/"+table.listPath+"/";
		File file = CUtil.createFile(path, table.listName, "jsp");
		
		try{
			BufferedWriter writer = new BufferedWriter(new FileWriter(file));     
			writer.write("<%@ page language=\"java\" contentType=\"text/html; charset=UTF-8\" pageEncoding=\"UTF-8\"%>\r\n"); 
			writer.write("<%@ include file=\"/WEB-INF/include/taglib.jsp\" %>\r\n");
			writer.write("\r\n");

			writer.write("<!DOCTYPE html>\r\n");
			writer.write("<html>\r\n");
			writer.write("<head>\r\n"); 
			writer.write("\t<title>信息列表</title>\r\n");
			writer.write("\t<meta charset=\"UTF-8\">\r\n");
			writer.write("\t<link type=\"text/css\" href=\"${ctxStatic}/css/style.css\" rel=\"stylesheet\"/>\r\n");
			writer.write("\t<script type=\"text/javascript\" src=\"${ctxStatic}/js/jquery/jquery-3.2.1.min.js\"></script>\r\n");
			writer.write("\t<script type=\"text/javascript\" src=\"${ctxStatic}/js/jquery/jquery-loading.js\"></script>\r\n");
			writer.write("\t<script type=\"text/javascript\" src=\"${ctxStatic}/js/layer/layer.min.js\"></script>\r\n");
			writer.write("\r\n");

			writer.write("\t<script type=\"text/javascript\">\r\n");
			
			writer.write("\t\tfunction doDelInfo(id){\r\n");
			writer.write("\t\t\tsubmitflag = false;\r\n");
			
			writer.write("\t\t\tif(confirm(\"确认要删除该信息吗?\")){\r\n");
			writer.write("\t\t\t\tsubmitflag = true;\r\n");
			writer.write("\t\t\t\twindow.location.href = '${ctx}"+table.action+"/doDel?id='+id;\r\n");
			writer.write("\t\t\t}\r\n");
			writer.write("\t\t}\r\n");

			writer.write("\t</script>\r\n");
			writer.write("</head>\r\n");
			
			writer.write("<body>\r\n");
			writer.write("<form id=\"form0\" action=\"${ctx}"+table.action+"/doList\" method=\"post\" >\r\n");
			writer.write("<div class=\"main\">\r\n");
			writer.write("\t<div class=\"page_title\"><span class=\"title_name\">信息列表： </span></div>\r\n");
			writer.write("\t<div class=\"select\">\r\n");
			
			writer.write("\t\t<div class=\"hang\">\r\n");
			writer.write("\t\t\t<span class=\"tj\">查询条件:<input type=\"text\" id=\"selStr\" name=\"selStr\" value=\"${selStr}\" style=\"width:120px;\" class=\"input\" /></span>\r\n");
			writer.write("\t\t\t<span class=\"tj\">\r\n");
			writer.write("\t\t\t\t<input type=\"submit\" id=\"selBtn\" value=\"查询\" class=\"a_btn_blue\" />\r\n");
			writer.write("\t\t\t\t<a id=\"addBtn\" href=\"${ctx}"+table.action+"/toAdd\" class=\"a_btn_blue\">新增</a>\r\n");
			writer.write("\t\t\t</span>\r\n");
			writer.write("\t\t</div>\r\n");
			writer.write("\t</div>\r\n");
			writer.write("\r\n");
			

			writer.write("\t<div class=\"content\">\r\n");
			writer.write("\t\t<table style=\"width:100%\" class=\"table_list\">\r\n");
			writer.write("\t\t\t<thead>\r\n");
			writer.write("\t\t\t\t<tr>\r\n");
			writer.write("\t\t\t\t\t<th width=\"40\">序号</th>\r\n");
			List<ColumnBean> colList = table.columnList;
			for( int i=0;i<colList.size();i++ ){
				ColumnBean col = colList.get(i);
				String colName = col.getColName();
				if( col.getColComment() != null && col.getColComment().length() > 0 ){
					colName = col.getColComment();
				}
				writer.write("\t\t\t\t\t<th>"+colName+"</th>\r\n");
			}
			writer.write("\t\t\t\t\t<th width=\"150\">操作</th>\r\n");
			writer.write("\t\t\t\t</tr>\r\n");
			writer.write("\t\t\t</thead>\r\n");

			writer.write("\t\t\t<c:forEach varStatus=\"index\" items=\"${pageInfo.list}\" var=\"obj\" >\r\n");
			writer.write("\t\t\t\t<tr>\r\n");
			writer.write("\t\t\t\t\t<td align=\"center\">${index.index+1}</td>\r\n");
			for( int i=0;i<colList.size();i++ ){
				ColumnBean col = colList.get(i);
				writer.write("\t\t\t\t\t<td align=\"center\">${obj."+col.getBeanName()+"}</td>\r\n");
			}
			writer.write("\t\t\t\t\t<td align=\"center\">\r\n");
			writer.write("\t\t\t\t\t\t<a id=\"edtBtn\" href=\"${ctx}"+table.action+"/toEdit?id=${obj.id}\" class=\"a_blue\">编辑</a>\r\n");
			writer.write("\t\t\t\t\t\t<a id=\"delBtn\" href=\"javascript:void(0);\" onclick=\"doDelInfo('${obj.id}')\" class=\"a_blue\">删除</a>\r\n");
			writer.write("\t\t\t\t\t\t<a id=\"vieBtn\" href=\"${ctx}"+table.action+"/toView?id=${obj.id}\" class=\"a_blue\">查看</a>\r\n");
			writer.write("\t\t\t\t\t</td>\r\n");
			writer.write("\t\t\t\t</tr>\r\n");
			writer.write("\t\t\t</c:forEach>\r\n");
			writer.write("\t\t</table>\r\n");
			writer.write("\t</div>\r\n");
			writer.write("\r\n");
			
			writer.write("\t<div class=\"page\">\r\n");
			writer.write("\t\t<p:pages cpage=\"${pageInfo.pageNum}\" totalPage=\"${pageInfo.pages}\" totalRow=\"${pageInfo.total}\" pageSize=\"${pageInfo.pageSize}\" url=\"${ctx}"+table.action+"/doPage\" styleClass=\"page\" theme=\"text\"/>\r\n");
			writer.write("\t</div>\r\n");
			writer.write("\t</div>\r\n");
			writer.write("</form>\r\n");
			writer.write("</body>\r\n"); 
			writer.write("<p:message/>\r\n");
			writer.write("</html>"); 
			
			writer.close();
			System.out.println(path+"/"+table.listName+" 创建成功...");
		}catch(Exception e){
			e.printStackTrace();
		}
	}
}
