package com.coob.aframe.fileCreate;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;

/**
 * Sql文件
 * @author JK.Sun
 * @version 20161015编辑
 */
public class CreateMappingOracle {
	
	/**
	 * 创建SQL XML配置文件
	 * @param projPath
	 * @param table
	 */
	public static void create(String projPath, ConfigTable table){
		String xmlFileName = null;
		
		//对应库表名称
		StringBuffer domianName = new StringBuffer(table.domainPath).append(".").append(table.domainName);

		//resultMap
		StringBuffer resultMapId = new StringBuffer("Rs").append(table.domainName).append("List");
		
		StringBuffer resultMap = new StringBuffer();
		StringBuffer colMaps = new StringBuffer();
		StringBuffer values = new StringBuffer();
		StringBuffer set = new StringBuffer();
		StringBuffer where = new StringBuffer();
		String whereId = null;
		String idType = null;
		int clen = table.colMaxLength;
		int blen = table.domMaxLength;
		
		for( ColumnBean col : table.columnList ){
			col.setColName(col.getColName().toLowerCase());
			String prop = CUtil.reName(col.getColName(), 3);
			
			if( "id".equals(col.getColName())){
				resultMap.append("\t\t<id column=\"id\" property=\"id\" jdbcType=\""+col.getColType()+"\"/>\r\n");
				//where.append("\t\t<if test=\"null!=id\"> id=#{id,jdbcType="+col.getColType()+"}</if>\r\n");
				where.append("\t\t<if test=\"null!=id\"> id=#{id}</if>\r\n");
				//whereId = "id=#{id,jdbcType="+col.getColType()+"}";
				whereId = "id=#{id}";
				idType = col.getBeanType();
			} else {
				
				if( colMaps.length()>0) colMaps.append(", ");
				colMaps.append(col.getColName());
				if( values.length()> 0 ) values.append(", ");
				values.append("#{").append(col.getBeanName()).append(", jdbcType="+col.getColType()+"}");
				//values.append("#{").append(col.getBeanName()).append("}");
				
				resultMap.append("\t\t<result column=\"").append(col.getColName()).append("\" ");
				for( int ii=col.getColLen(); ii<clen; ii ++ ) resultMap.append(" ");
				resultMap.append("property=\"").append(col.getBeanName()).append("\" ");
				for( int jj=col.getBeanLen(); jj<blen; jj ++ ) resultMap.append(" ");
				resultMap.append("jdbcType=\"").append(col.getColType()).append("\"/>\r\n");
				set.append("\t\t\t<if test=\"null!=").append(prop).append("\"> ").append(col.getColName()).append("=#{").append(prop).append(", jdbcType="+col.getColType()+"},</if>\r\n");
				//set.append("\t\t\t<if test=\"null!=").append(prop).append("\"> ").append(col.getColName()).append("=#{").append(prop).append("},</if>\r\n");
				if( col.getColType().equals("INTEGER")){
					where.append("\t\t<if test=\"null!=").append(prop).append("\"> and ").append(col.getColName()).append("=#{").append(prop).append(", jdbcType="+col.getColType()+"}</if>\r\n");
					//where.append("\t\t<if test=\"null!=").append(prop).append("\"> and ").append(col.getColName()).append("=#{").append(prop).append("}</if>\r\n");
				}else {
					where.append("\t\t<if test=\"null!=").append(prop).append(" and ").append(prop).append("!=''\"> and ").append(col.getColName()).append("=#{").append(prop).append(", jdbcType="+col.getColType()+"}</if>\r\n");
					//where.append("\t\t<if test=\"null!=").append(prop).append(" and ").append(prop).append("!=''\"> and ").append(col.getColName()).append("=#{").append(prop).append("}</if>\r\n");
				}
			}
		}
		
		//创建Sql配置文件
		File xmlFile = CUtil.createFile(projPath, table.tableName, "xml");
		xmlFileName = xmlFile.getName();
		try{   
			BufferedWriter writer = new BufferedWriter(new FileWriter(xmlFile));     
			writer.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n"); 
			writer.write("<!DOCTYPE mapper PUBLIC \"-//mybatis.org//DTD Mapper 3.0//EN\" \"http://mybatis.org/dtd/mybatis-3-mapper.dtd\">\r\n");

			writer.write("<mapper namespace=\""+table.daoPath+"."+table.daoName+"\">\r\n");
			writer.write("\t<resultMap id=\""+resultMapId+"\" type=\""+domianName+"\">\r\n");
			writer.write(resultMap.toString());
			writer.write("\t</resultMap>\r\n");
			writer.write("\r\n");

			writer.write("\t<insert id=\"insert\" parameterType=\""+domianName+"\" useGeneratedKeys=\"true\" keyProperty=\"id\">\r\n");
			writer.write("\t\tinsert into "+table.tableName+" ("+colMaps+")\r\n");
			writer.write("\t\tvalues("+values+")\r\n");
			writer.write("\t</insert>\r\n");
			writer.write("\r\n");

			writer.write("\t<update id=\"update\" parameterType=\""+domianName+"\">\r\n");
			writer.write("\t\tupdate "+table.tableName+" \r\n");
			writer.write("\t\t<set>\r\n");
			writer.write(set.toString());
			writer.write("\t\t</set>\r\n");
			writer.write("\t\twhere "+whereId+"\r\n");
			writer.write("\t</update>\r\n");
			writer.write("\r\n");

			writer.write("\t<update id=\"deleteById\" parameterType=\""+idType+"\">\r\n");
			writer.write("\t\tupdate "+table.tableName +" set state=-9 where "+whereId+"\r\n");
			writer.write("\t</update>\r\n");
			writer.write("\r\n");
			
			writer.write("\t<delete id=\"physicalDeleteById\" parameterType=\""+idType+"\">\r\n");
			writer.write("\t\tdelete from "+table.tableName +" where "+whereId+"\r\n");
			writer.write("\t</delete>\r\n");
			writer.write("\r\n");

			writer.write("\t<select id=\"selectById\" resultMap=\""+resultMapId+"\" parameterType=\""+idType+"\">\r\n");
			writer.write("\t\tselect * from "+table.tableName+" where "+whereId+"\r\n");
	    	writer.write("\t</select>\r\n");
	    	writer.write("\r\n");

	    	writer.write("\t<select id=\"selectForCount\" resultType=\"int\" parameterType=\"java.util.Map\" >\r\n");
	    	writer.write("\t\tselect count(id) from "+table.tableName+" \r\n");
	    	writer.write("\t\t<where>\r\n");
	    	writer.write(where.toString());
	    	writer.write("\t\t</where>\r\n");
	    	writer.write("\t</select>\r\n");
	    	writer.write("\r\n");

	    	writer.write("\t<select id=\"selectByParams\" resultMap=\""+resultMapId+"\" parameterType=\"java.util.Map\">\r\n");
	    	writer.write("\t\tselect * from "+table.tableName+" \r\n");
	    	writer.write("\t\t<where>\r\n");
	    	writer.write(where.toString());
	    	writer.write("\t\t</where>\r\n");
	    	writer.write("\t</select>\r\n");
	    	writer.write("</mapper>");
			writer.close();
			
			System.out.println(projPath+"/"+xmlFileName +" 创建成功...");
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	//Configuration.xml中添加配置文件
	@SuppressWarnings("unused")
	private static void resetConfiguration(String projPath, String fileName){
		String path = projPath+"src/Configuration.xml";
		File _file = new File(path);
		List<String> tList = new ArrayList<String>();
		boolean isCZ = false;
		int index = 0;
		int i = 0;
		try{
			BufferedReader bw = new BufferedReader(new FileReader(_file));
			String line = null;
			while((line = bw.readLine()) != null){
				tList.add(line);
				if(line.indexOf("</mappers>")>-1){
					index = i;
				}
				if( line.indexOf("sqlmaps/"+fileName)> -1){
					isCZ = true;
				}
				i++;
			}
			bw.close();
			if( !isCZ ){
				tList.add(index, "\t\t<mapper resource=\"sqlmaps/"+fileName+"\"/>");
				BufferedWriter writer = new BufferedWriter(new FileWriter(_file));
				for( String str : tList){
					writer.write(str);
					writer.newLine();
				}
				writer.flush();
				writer.close();
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}
}
