package com.coob.aframe.fileCreate;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;

public class CreateService {
	
	public static void create(String projPath, ConfigTable table, ConfigBean config){
		createService(projPath, table, config);
	}
	
	private static void createService(String basePath, ConfigTable table, ConfigBean config){
		String idType = "Integer";
		for( ColumnBean col : table.columnList ){
			if( "id".equals(col.getColName())){
				idType = col.getBeanType();
				break;
			}
		}

		String p = basePath+table.servicePath.replace(".", "/");
		File file = CUtil.createFile(p, table.serviceName, "java");
		try{ 
			BufferedWriter writer = new BufferedWriter(new FileWriter(file));     
			writer.write("package "+table.servicePath+";\r\n");
			writer.write("\r\n");
			writer.write("import java.util.List;\r\n");
			writer.write("import java.util.Map;\r\n");
			writer.write("import org.springframework.beans.factory.annotation.Autowired;\r\n");
			writer.write("import org.springframework.stereotype.Service;\r\n");
			writer.write("import org.springframework.transaction.annotation.Transactional;\r\n");
			writer.write("\r\n");
			writer.write("import "+table.domainPath+"."+table.domainName+";\r\n");
			writer.write("import "+table.daoPath+"."+table.daoName+";\r\n");
			writer.write("\r\n");

			writer.write("@Service\r\n");
			writer.write("@Transactional\r\n");
			writer.write("public class "+table.serviceName+" {\r\n");
			writer.write("\t@Autowired\r\n");
			writer.write("\tprivate "+table.daoName+" "+table.daoNamexx+";\r\n");
			writer.write("\r\n\r\n");
			
			writer.write("\t/**\r\n");
			writer.write("\t * 新增\r\n");
			writer.write("\t * @param "+table.domainNamexx+"\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\tpublic int insert("+table.domainName+" "+table.domainNamexx+"){\r\n");
			writer.write("\t\tint flag = this."+table.daoNamexx+".insert("+table.domainNamexx+");\r\n");
			writer.write("\t\treturn flag;\r\n");
			writer.write("\t}\r\n");
			writer.write("\r\n\r\n");
			
			writer.write("\t/**\r\n");
			writer.write("\t * 修改\r\n");
			writer.write("\t * @param "+table.domainNamexx+"\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\tpublic int update("+table.domainName+" "+table.domainNamexx+"){\r\n");
			writer.write("\t\tint flag = this."+table.daoNamexx+".update("+table.domainNamexx+");\r\n");
			writer.write("\t\treturn flag;\r\n");
			writer.write("\t}\r\n");
			writer.write("\r\n");
			
			writer.write("\t/**\r\n");
			writer.write("\t * 逻辑删除\r\n");
			writer.write("\t * @param id\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\tpublic int deleteById("+idType+" id){\r\n");
			writer.write("\t\tint flag = this."+table.daoNamexx+".deleteById(id);\r\n");
			writer.write("\t\treturn flag;\r\n");
			writer.write("\t}\r\n");
			writer.write("\r\n\r\n");
			
			writer.write("\t/**\r\n");
			writer.write("\t * 物理删除\r\n");
			writer.write("\t * @param id\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\tpublic int physicalDeleteById("+idType+" id){\r\n");
			writer.write("\t\tint flag = this."+table.daoNamexx+".physicalDeleteById(id);\r\n");
			writer.write("\t\treturn flag;\r\n");
			writer.write("\t}\r\n");
			writer.write("\r\n\r\n");
			
			writer.write("\t/**\r\n");
			writer.write("\t * 根据id查询信息\r\n");
			writer.write("\t * @param id\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\tpublic "+table.domainName+" selectById("+idType+" id){\r\n");
			writer.write("\t\treturn this."+table.daoNamexx+".selectById(id);\r\n");
			writer.write("\t}\r\n");
			writer.write("\r\n\r\n");

			writer.write("\t/**\r\n");
			writer.write("\t * 条件查询列表\r\n");
			writer.write("\t * @param params\r\n");
			writer.write("\t * @return\r\n");
			writer.write("\t */\r\n");
			writer.write("\tpublic List<"+table.domainName+"> selectByParams(Map<String,Object> params){\r\n");
			writer.write("\t\treturn this."+table.daoNamexx+".selectByParams(params);\r\n");
			writer.write("\t}\r\n");
			writer.write("\r\n\r\n");

			writer.write("\r\n");
			writer.write("}\r\n");
			writer.close();
			
			System.out.println(table.servicePath+"."+table.serviceName+" 创建成功...");
		}catch(Exception e){
			e.printStackTrace();
		}
	}
}
