package com.coob.aframe.tag;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;
import java.io.IOException;

/**
 * 自定义标签-分页标签
 * Created by JK.Sun on 2017/8/12 0012.
 */
public class PageTag extends TagSupport {
	private static final long serialVersionUID = -5792327123085965494L;
	
	private String cpage;
    private String totalPage;
    private String totalRow;
    private String form;
    private String url;
    private String pageSize;
    private String styleClass;
    private String theme;

    //页面用例：基于session：
    //<p:pages cpage="${pageInfo.pageNum}" totalPage="${pageInfo.pages}" totalRow="${pageInfo.total}" pageSize="${pageInfo.pageSize}" url="${ctx}/sys/depart/doPage" styleClass="page" theme="text"/>
    //页面用例：基于表单
    //<p:pages cpage="${pageInfo.pageNum}" totalPage="${pageInfo.pages}" totalRow="${pageInfo.total}" pageSize="${pageInfo.pageSize}" form="form0" styleClass="page" theme="text"/>

    @SuppressWarnings("static-access")
	@Override
    public int doStartTag() throws JspException {
    	JspWriter out = this.pageContext.getOut();

        StringBuffer htmlStr = new StringBuffer();
        htmlStr.append("共"+this.totalRow+"行  ");
        htmlStr.append("第 " + cpage + "/" + totalPage + " 页&nbsp;\r\n");

        htmlStr.append("<span ");
        if (styleClass != null) {
            htmlStr.append(" class='" + styleClass + "'");
        } 
        htmlStr.append(">\r\n");
        
        boolean formFlag = false;
        if( form != null && form.length() > 0 ){
        	formFlag = true;
        }
        
        htmlStr.append("<a id=\"syPageBtnA\" href=\"javascript:void(0);\" onclick=\"ggttooListPage(0)\">[首页]</a>\r\n");
        htmlStr.append("<a id=\"syyPageBtnA\" href=\"javascript:void(0);\" onclick=\"ggttooListPage(-1)\">[上一页]</a>\r\n");
        htmlStr.append("<a id=\"xyyPageBtnA\" href=\"javascript:void(0);\" onclick=\"ggttooListPage(1)\">[下一页]</a>\r\n");
        htmlStr.append("<a id=\"myPageBtnA\" href=\"javascript:void(0);\" onclick=\"ggttooListPage(9)\">[末页]</a>\r\n");
        
        //跳转
        htmlStr.append(" <input type='text' id='gottoPNum' value='"+ cpage + "' />\r\n");
        htmlStr.append("<a id=\"myPageBtnGt\" href=\"javascript:void(0);\" onclick=\"ggttooListPage(99)\">[跳转]</a>\r\n");
        
        //form跳转
        if( formFlag ){
        	htmlStr.append("<input type=\"hidden\" name=\"pageSize\" value=\"").append(pageSize).append("\" />\r\n");
    		htmlStr.append("<input type=\"hidden\" id=\"pageNum\" name=\"pageNum\" value=\"1\" />\r\n");
        }
        
        htmlStr.append("</span>\r\n");
        
        htmlStr.append("<script type=\"text/javascript\">\r\n");
        htmlStr.append("var listCurPppage=" + cpage + ";\r\n");
        htmlStr.append("var listTotPppage=" + totalPage + ";\r\n");
        htmlStr.append("function ggttooListPage(bs){\r\n");
        htmlStr.append("var _gnum=listCurPppage;\r\n");
        htmlStr.append("if(bs==0){_gnum=1;}\r\n");
        htmlStr.append("else if(bs==-1){_gnum--;}\r\n");
        htmlStr.append("else if(bs==1){_gnum++;}\r\n");
        htmlStr.append("else if(bs==9){_gnum=listTotPppage;}\r\n");
        htmlStr.append("else if(bs==99){_gnum=document.getElementById('gottoPNum').value;}\r\n");
        htmlStr.append("if(_gnum<1){_gnum=1;}\r\n");
        htmlStr.append("if(_gnum>listTotPppage ){_gnum = listTotPppage;}\r\n");
        if( formFlag ){
        	htmlStr.append("document.getElementById('pageNum').value=_gnum\r\n;");
        	if( url != null && url.length() > 0 ){
        		htmlStr.append("document.getElementById('"+form+"').action='"+url+"';\r\n");
        	}
        	htmlStr.append("document.getElementById('"+form+"').submit();\r\n");
        } else {
        	htmlStr.append("window.location.href='"+url+"?pageNum='+_gnum+'&pageSize="+pageSize+"';\r\n");
        }
        htmlStr.append("}\r\n");
        htmlStr.append("</script>");
        
        try {
            out.println(htmlStr);
        } catch (IOException e) {
            e.printStackTrace();
        }

        return this.EVAL_PAGE;
    }

    
    public String getTheme() {
        return theme;
    }
    
    public void setTheme(String theme) {
        this.theme = theme;
    }
    
    public String getStyleClass() {
        return styleClass;
    }
    
    public void setStyleClass(String styleClass) {
        this.styleClass = styleClass;
    }
    
    public String getCpage() {
        return cpage;
    }
    
    public void setCpage(String cpage) {
        this.cpage = cpage;
    }
    
    public String getUrl() {
        return url;
    }
    
    public void setUrl(String url) {
        this.url = url;
    }
    
    public String getTotalPage() {
        return totalPage;
    }
    
    public void setTotalPage(String totalPage) {
        this.totalPage = totalPage;
    }
    
    public String getTotalRow() {
        return totalRow;
    }
    
    public void setTotalRow(String totalRow) {
        this.totalRow = totalRow;
    }
    
    public String getPageSize() {
        return pageSize;
    }
    
    public void setPageSize(String pageSize) {
        this.pageSize = pageSize;
    }

	public String getForm() {
		return form;
	}

	public void setForm(String form) {
		this.form = form;
	}
}
