package com.coob.aframe.tag;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;
import java.io.IOException;
import java.math.BigDecimal;

public class SpanVTag extends TagSupport {
	private static final long serialVersionUID = -8562454399729982751L;
	
	private String value;
	private String width;
	private String mwidth;
	private String css;
	private Integer len;
	
	@SuppressWarnings("static-access")
	@Override
    public int doStartTag() throws JspException {
        JspWriter out = this.pageContext.getOut();
        
        if( value != null && value.length()>0 && !value.equals("null") && len != null ){
        	BigDecimal bd = new BigDecimal(value);
        	value = bd.setScale(2, BigDecimal.ROUND_HALF_UP).toString();
    	}
        
        StringBuffer htmlStr = new StringBuffer("<span");
        if( width != null ){
        	htmlStr.append(" style=\"min-width:"+width+"px;\"");
        	if( css != null ){
        		htmlStr.append(" class=\""+css+"\"");
        	} else {
        		htmlStr.append(" class=\"tx_c_b\"");
        	}
        } else {
	        if( mwidth != null ){
	        	htmlStr.append(" style=\"min-width:"+mwidth+"px;\"");
	        }
	        if( value == null || value.length() == 0 ){
	        	htmlStr.append(" class=\"tx_c_b\"");
	        } else {
	        	htmlStr.append(" class=\"tx_c\"");
	        }
        }
        htmlStr.append(">").append(value).append("</span>");
        try {
            out.print(htmlStr);
        } catch (IOException e) {
            e.printStackTrace();
        }
        
        return this.EVAL_PAGE;
	}

	
	public String getValue() {
		return value;
	}

	public void setValue(String value) {
		this.value = value;
	}

	public String getMwidth() {
		return mwidth;
	}

	public void setMwidth(String mwidth) {
		this.mwidth = mwidth;
	}

	public String getWidth() {
		return width;
	}

	public void setWidth(String width) {
		this.width = width;
	}

	public String getCss() {
		return css;
	}

	public void setCss(String css) {
		this.css = css;
	}


	public Integer getLen() {
		return len;
	}


	public void setLen(Integer len) {
		this.len = len;
	}
}
