package com.coob.aframe.tag;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;
import java.io.IOException;

public class SubStrTag extends TagSupport {
	private static final long serialVersionUID = -8281538986348621804L;
	
	private String value;
	private String length;
	
	@SuppressWarnings("static-access")
	@Override
    public int doStartTag() throws JspException {
        JspWriter out = this.pageContext.getOut();

        StringBuffer htmlStr = new StringBuffer("<span title=\""+value+"\">");
        if( value != null ){
        	if( length == null || length.length() == 0 ){
        		htmlStr.append(value);
        	} else {
        		int l = Integer.parseInt(length);
        		if( value.length() > l ){
        			htmlStr.append(value.substring(0, l-2)).append("...");
        		} else {
        			htmlStr.append(value);
        		}
        	}
        }
        htmlStr.append("</span>");
        try {
            out.println(htmlStr);
        } catch (IOException e) {
            e.printStackTrace();
        }
        
        return this.EVAL_PAGE;
	}

	
	public String getValue() {
		return value;
	}

	public void setValue(String value) {
		this.value = value;
	}

	public String getLength() {
		return length;
	}

	public void setLength(String length) {
		this.length = length;
	}
}
