package com.coob.aframe.util;

import java.io.UnsupportedEncodingException;
import java.util.Base64;


/**
 * Base64转码、解码工具
 * @author Administrator
 *
 */
public class Base64Util {

	
	/**
	 * 字符串转码
	 * @param text
	 * @param encode
	 * @return
	 */
	public static String encode(String text, String encode){
		String val = null;
		if( text != null ){
			try {
				Base64.Encoder encoder = Base64.getEncoder();
				byte[] b = text.getBytes(encode);
				val = encoder.encodeToString(b);
			} catch (UnsupportedEncodingException e) {
				e.printStackTrace();
			}
		}
		return val;
	}
	
	
	/**
	 * 字符串转码
	 * @param text
	 * @return
	 */
	public static String encode(String text){
		return encode(text, "UTF-8");
	}
	
	
	/**
	 * 字符串解码
	 * @param text
	 * @param encode
	 * @return
	 */
	public static String decode(String text, String encode){
		String val = null;
		if( text != null ){
			try {
				Base64.Decoder decoder = Base64.getDecoder();
				byte[] b = decoder.decode(text);
				val = new String(b, encode);
			} catch (UnsupportedEncodingException e) {
				e.printStackTrace();
			}
		}
		return val;
	}
	
	
	/**
	 * 字符串解码
	 * @param text
	 * @return
	 */
	public static String decode(String text){
		return decode(text, "UTF-8");
	}
	
	
	public static void main(String[] args) {
		String v2 = Base64Util.decode("aFJxcDdLSytCZm89");
		System.out.println("报文："+v2);
		v2 = DESUtil.decrypt(v2);
		System.out.println("报文："+v2);
	}
}
