package com.coob.mis.cx.controller;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import com.coob.aframe.base.BaseController;
import com.coob.mis.cx.domain.MisQyxxb;
import com.coob.mis.cx.service.MisQyxxbService;

/**
 * 
 * @author JK.Sun
 *
 */
@RequestMapping("/mis/cx/qyxxb")
@Controller
public class MisQyxxbController extends BaseController  {
	@Autowired
	private MisQyxxbService misQyxxbService;
	
	
	/**
	 * 查询部门信息列表
	 * @param model
	 * @return
	 */
	@RequestMapping(value = "/doList", method = {RequestMethod.GET, RequestMethod.POST})
	public String doList(Integer jglx, String qymc, Integer pageNum, Model model) {
		Map<String,Object> params = new HashMap<String, Object>();
		params.put("qymc", qymc);
		params.put("jglx", jglx);
		this.setParamToSession(params);
		
		super.offsetPage(pageNum);
		List<MisQyxxb> list = this.misQyxxbService.selectByParams(params);
		PageInfo<MisQyxxb> pageInfo = new PageInfo<>(list);

		model.addAttribute("qymc", qymc);
		model.addAttribute("jglx", jglx);
		model.addAttribute("pageInfo", pageInfo);

		return "pages/mis/qyxxb/list";
	}

	
	/**
	 * 详情
	 * @param id
	 * @param model
	 * @return
	 */
	@RequestMapping(value = "/toView")
	public String toView(Integer id, Model model) {
		MisQyxxb qyxx = this.misQyxxbService.selectById(id);

		model.addAttribute("qyxx", qyxx);

		return "pages/mis/qyxxb/view";
	}


}
