package com.coob.mis.cx.dao;

import java.util.List;
import java.util.Map;

import com.coob.mis.cx.domain.MisQyxxb;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.stereotype.Repository;

/**
 * Mis库企业信息
 * @author Administrator
 *
 */
@MapperScan
@Repository
public interface MisQyxxbDao {

	/**
	 * 根据id查询信息
	 * @param id
	 * @return
	 */
	MisQyxxb selectById(Integer id);
	
	/**
	 * 根据企业编码查询信息
	 * @param qybm
	 * @return
	 */
	MisQyxxb selectByQybm(String qybm);
	
	/**
	 * 根据企业名称查询
	 * @param qymc
	 * @return
	 */
	MisQyxxb selectByQymc(String qymc);
	
	/**
	 * 根据注册号/社会信用代码查询
	 * @param zch
	 * @return
	 */
	MisQyxxb selectByZch(String zch);
	
	/**
	 * 根据机构类型查询企业信息
	 * @param jglx
	 * @return
	 */
	List<MisQyxxb> selectListByJglx(Integer jglx);

	/**
	 * 查询所有企业信息
	 * @return
	 */
	List<MisQyxxb> selectListAll();
	
	/**
	 * 条件查询数量
	 * @param params
	 * @return
	 */
	int selectForCount(Map<String,Object> params);

	/**
	 * 条件查询列表
	 * @param params
	 * @return
	 */
	List<MisQyxxb> selectByParams(Map<String,Object> params);

}
