package com.coob.mis.cx.dao;

import java.util.List;
import java.util.Map;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.stereotype.Repository;

import com.coob.mis.cx.domain.MisXmxx;


/**
 * 开发项目信息处理Dao
 * @author Administrator
 *
 */
@MapperScan
@Repository
public interface MisXmxxDao {

	/**
	 * 新增信息
	 * @param xmxx
	 * @return
	 */
	int insert(MisXmxx xmxx);

	/**
	 * 修改信息
	 * @param xmxx
	 * @return
	 */
	int update(MisXmxx xmxx);

	/**
	 * 根据id查询信息
	 * @param id
	 * @return
	 */
	MisXmxx selectById(Integer id);
	
	/**
	 * 根据项目编号查询信息
	 * @param xmbh
	 * @return
	 */
	MisXmxx selectByXmbh(String xmbh);
	
	/**
	 * 根据项目名称查询信息
	 * @param xmmc
	 * @return
	 */
	MisXmxx selectByXmmc(String xmmc);
	
	/**
	 * 查询所有项目信息
	 *  农村除外
	 * @return
	 */
	List<MisXmxx> selectListAll();

	/**
	 * 条件查询数量
	 * @param params
	 * @return
	 */
	int selectForCount(Map<String,Object> params);

	/**
	 * 条件查询列表
	 * @param params
	 * @return
	 */
	List<MisXmxx> selectByParams(Map<String,Object> params);

}
