package com.coob.mis.cx.service;

import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.coob.mis.cx.domain.MisHouse;
import com.coob.mis.cx.dao.MisHouseDao;

@Service
@Transactional
public class MisHouseService {
	@Autowired
	private MisHouseDao misHouseDao;


	/**
	 * 新增
	 * @param misHouse
	 * @return
	 */
	public int insert(MisHouse misHouse){
		int flag = this.misHouseDao.insert(misHouse);
		return flag;
	}


	/**
	 * 修改
	 * @param misHouse
	 * @return
	 */
	public int update(MisHouse misHouse){
		int flag = this.misHouseDao.update(misHouse);
		return flag;
	}

	/**
	 * 逻辑删除
	 * @param id
	 * @return
	 */
	public int deleteById(Integer id){
		int flag = this.misHouseDao.deleteById(id);
		return flag;
	}


	/**
	 * 物理删除
	 * @param id
	 * @return
	 */
	public int physicalDeleteById(Integer id){
		int flag = this.misHouseDao.physicalDeleteById(id);
		return flag;
	}


	/**
	 * 根据id查询信息
	 * @param id
	 * @return
	 */
	public MisHouse selectById(Integer id){
		return this.misHouseDao.selectById(id);
	}


	/**
	 * 条件查询列表
	 * @param params
	 * @return
	 */
	public List<MisHouse> selectByParams(Map<String,Object> params){
		return this.misHouseDao.selectByParams(params);
	}



}
