package com.coob.mis.cx.service;

import com.coob.mis.cx.dao.MisQyxxbDao;
import com.coob.mis.cx.domain.MisQyxxb;

import org.apache.ibatis.session.RowBounds;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * Mis库企业信息数据处理
 */
@Service
@Transactional
public class MisQyxxbService {
	@Autowired
    private MisQyxxbDao misQyxxbDao;
	
	/**
	 * 根据id查询信息
	 * @param id
	 * @return
	 */
	public MisQyxxb selectById(Integer id){
		return this.misQyxxbDao.selectById(id);
	}
	
	
	/**
	 * 根据企业编码查询信息
	 * @param qybm
	 * @return
	 */
	public MisQyxxb selectByQybm(String qybm){
		if( qybm == null || qybm.equals("null") || qybm.length() == 0 ) {
			return null;
		}
		return this.misQyxxbDao.selectByQybm(qybm);
	}
	
	
	/**
	 * 根据企业名称查询
	 * @param qymc
	 * @return
	 */
	public MisQyxxb selectByQymc(String qymc){
		if( qymc == null || qymc.equals("null") || qymc.length() == 0 ) {
			return null;
		}
		return this.misQyxxbDao.selectByQymc(qymc);
	}
	
	
	/**
	 * 根据注册号/社会信用代码查询
	 * @param zch
	 * @return
	 */
	public MisQyxxb selectByZch(String zch){
		if( zch == null || zch.equals("null") || zch.length() == 0 ) {
			return null;
		}
		return this.misQyxxbDao.selectByZch(zch);
	}
	
	
	/**
	 * 根据机构类型查询企业信息
	 * @param jglx
	 * @return
	 */
	public List<MisQyxxb> selectListByJglx(Integer jglx){
		return this.misQyxxbDao.selectListByJglx(jglx);
	}

	
	/**
	 * 查询所有企业信息
	 * @return
	 */
	public List<MisQyxxb> selectListAll(){
		return this.misQyxxbDao.selectListAll();
	}
	
	
	/**
	 * 条件查询数量
	 * @param params
	 * @return
	 */
	public int selectForCount(Map<String,Object> params){
		return this.misQyxxbDao.selectForCount(params);
	}

	
	/**
	 * 条件查询列表（不分页）
	 * @param params
	 * @return
	 */
	public List<MisQyxxb> selectByParams(Map<String,Object> params){
		return this.misQyxxbDao.selectByParams(params);
	}

}
