package com.coob.mis.cx.service;

import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.coob.mis.cx.dao.MisXmxxDao;
import com.coob.mis.cx.domain.MisXmxx;


/**
 * Mis库项目信息数据管理
 * @author JK.Sun
 *
 */
@Service
@Transactional
public class MisXmxxService {
	@Autowired
	private MisXmxxDao misXmxxDao;
	
	
	/**
	 * 新增信息
	 * @param xmxx
	 * @return
	 */
	public int insert(MisXmxx xmxx){
		return this.misXmxxDao.insert(xmxx);
	}

	
	/**
	 * 修改信息
	 * @param xmxx
	 * @return
	 */
	public int update(MisXmxx xmxx){
		return this.misXmxxDao.update(xmxx);
	}

	
	/**
	 * 根据id查询信息
	 * @param id
	 * @return
	 */
	public MisXmxx selectById(Integer id){
		return this.misXmxxDao.selectById(id);
	}
	
	
	/**
	 * 根据项目编号查询信息
	 * @param xmbh
	 * @return
	 */
	public MisXmxx selectByXmbh(String xmbh){
		return this.misXmxxDao.selectByXmbh(xmbh);
	}
	
	
	/**
	 * 根据项目名称查询信息
	 * @param xmmc
	 * @return
	 */
	public MisXmxx selectByXmmc(String xmmc){
		return this.misXmxxDao.selectByXmmc(xmmc);
	}
	
	
	/**
	 * 查询所有项目信息
	 *  农村除外
	 * @return
	 */
	public List<MisXmxx> selectListAll(){
		return this.misXmxxDao.selectListAll();
	}

	
	/**
	 * 条件查询数量
	 * @param params
	 * @return
	 */
	public int selectForCount(Map<String,Object> params){
		return this.misXmxxDao.selectForCount(params);
	}
	

	/**
	 * 条件查询列表（不分页）
	 * @param params
	 * @return
	 */
	public List<MisXmxx> selectByParams(Map<String,Object> params){
		return this.misXmxxDao.selectByParams(params);
	}
	
	
}
