package com.coob.zhfg.system.controller;

import com.coob.aframe.base.BaseController;
import com.coob.zhfg.system.domain.User;
import com.coob.zhfg.system.service.UserService;
import com.github.pagehelper.PageInfo;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 用户信息管理
 */
@Controller
@RequestMapping("/sys/user")
public class UserController extends BaseController {
    @Resource
    private UserService userService;


    /**
     * 查询部门信息列表
     * @param xm
     * @param dlzh
     * @return list.jsp
     */
    @RequestMapping(value = "/doList")
    public String doList(String xm, String dlzh, Integer pageNum, Model model) {
        Map<String, Object> params = new HashMap<>();
        params.put("xm", xm);
        params.put("dlzh", dlzh);
        params.put("state", 1);
        super.setParamToSession(params);

        super.offsetPage(pageNum);
        List<User> list = this.userService.selectByParams(params);
        PageInfo<User> pageInfo = new PageInfo<>(list);

        model.addAttribute("pageInfo", pageInfo);
        model.addAttribute("xm", xm);
        model.addAttribute("dlzh", dlzh);

        return "pages/system/user/list";
    }

    /**
     * 分页处理
     * @param pageNum
     * @param model
     * @return
     */
    @RequestMapping(value = "/doPage")
    public String doPage(Integer pageNum, Model model) {
        Map<String,Object> params = this.getSessionParam();

        super.offsetPage(pageNum);
        List<User> list = this.userService.selectByParams(params);
        PageInfo<User> pageInfo = new PageInfo<>(list);

        model.addAttribute("pageInfo", pageInfo);
        model.addAttribute("xm", (String)params.get("xm"));
        model.addAttribute("dlzh", (String)params.get("dlzh"));

        return "pages/system/user/list";
    }



    /**
     * 显示详情
     * @param id
     * @param model
     * @return
     */
    @RequestMapping(value = "/toView")
    public String toView(Integer id, Model model) {
        User user = this.userService.selectById(id);
        model.addAttribute("user", user);

        return "pages/system/user/view";
    }


}
