package com.coob.zhfg.system.dao;

import com.coob.zhfg.system.domain.Role;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.session.RowBounds;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;


/**
 * 角色管理Dao
 * @author JK.Sun
 * @version 20210308
 */
public interface RoleDao {

	/**
	 * 新增
	 * @param role
	 * @return
	 */
	int insert(Role role);

	/**
	 * 修改
	 * @param role
	 * @return
	 */
	int update(Role role);

	/**
	 * 根据类别，设置默认标识为0，用于设置新的默认时，取消原默认
	 * @param roleType
	 * @return
	 */
	int updateMrbsByType(Integer roleType);

	/**
	 * 逻辑删除
	 * @param id
	 * @return
	 */
	int deleteById(Integer id);

	/**
	 * 根据id查询
	 * @param id
	 * @return
	 */
	Role selectById(Integer id);

	/**
	 * 根据用户id，查询已经分配的角色
	 * @param userId
	 * @param type
	 * @return
	 */
	List<Role> selectByUserId(@Param("userId")Integer userId, @Param("type") Integer type);

	/**
	 * 根据类别查询角色列表
	 * @param roleType
	 * @return
	 */
	List<Role> selectListByType(@Param("roleType")Integer roleType);

	/**
	 * 条件查询
	 * @param params
	 * @return
	 */
	int selectForCount(Map<String, Object> params);

	/**
	 * 条件查询
	 * @param params
	 * @return
	 */
	List<Role> selectByParams(Map<String, Object> params);

	/**
	 * 条件查询
	 * @param params
	 * @param rowBounds
	 * @return
	 */
	List<Role> selectByParams(Map<String, Object> params, RowBounds rowBounds);

}
