package com.coob.zhfg.system.service;

import com.coob.zhfg.system.dao.MenuDao;
import com.coob.zhfg.system.dao.RoleDao;
import com.coob.zhfg.system.dao.RoleMenuDao;
import com.coob.zhfg.system.dao.UserRoleDao;
import com.coob.zhfg.system.domain.Menu;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;


/**
 * 角色管理
 *
 * @author JK.Sun
 */
@Service
@Transactional
public class RoleService {
    @Autowired
    private RoleDao roleDao;
    @Autowired
    private MenuDao menuDao;
    @Autowired
    private RoleMenuDao roleMenuDao;
    @Autowired
    private UserRoleDao userRoleDao;


    /**
     * 根据用户Id查询操作权限
     *
     * @param userId
     * @return
     */
    public List<Menu> selectMenuListByUserId(Integer userId) {
        return this.menuDao.selectByUserId(Menu.XYBS, userId);
    }

    public List<Menu> selectMenuList() {
        return this.menuDao.selectList(Menu.XYBS);
    }

}
