package com.coob.zhfg.system.service;

import com.coob.zhfg.system.dao.UserDao;
import com.coob.zhfg.system.domain.User;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

@Service
public class UserService {
    @Resource
    private UserDao userDao;

    /**
     * 根据id查询信息
     * @param id
     * @return
     */
    public User selectById(Integer id){
        return this.userDao.selectById(id);
    }

    /**
     * 根据登录账号查询用户信息
     * @param dlzh
     * @return
     */
    public User selectByDlzh(String dlzh){
        return this.userDao.selectByDlzh(dlzh);
    }

    /**
     * 查询所有有效的用户信息
     * @return
     */
    public List<User> selectListAll(){
        return this.userDao.selectListAll();
    }

    /**
     * 条件查询列表
     * @param params
     * @return
     */
    public List<User> selectByParams(Map<String,Object> params){
        return this.userDao.selectByParams(params);
    }

}
