package com.coob.zhfg.tj.controller;

import com.coob.aframe.base.BaseController;
import com.coob.zhfg.tj.domain.TjSpf;
import com.coob.zhfg.tj.service.TjSpfService;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;

import javax.annotation.Resource;

/**
 * 商品房整体统计数据管理
 */
@Controller
@RequestMapping("/zhfg/tj/spf")
public class TjSpfController extends BaseController {
    @Resource
    private TjSpfService tjSpfService;


    /**
     * 查看商品房整体统计数据
     * @param model
     * @return
     */
    @RequestMapping(value = "/toViewSpf")
    public String toViewSpf(Model model){
        TjSpf tj = this.tjSpfService.selectSpfTj();

        model.addAttribute("tj", tj);

        return "pages/tongji/spf/spf";
    }

    /**
     * 查看在建在售项目统计数据
     * @param model
     * @return
     */
    @RequestMapping(value = "/toViewZj")
    public String toViewZj(Model model){
        TjSpf tj = this.tjSpfService.selectZjxmTj();

        model.addAttribute("tj", tj);

        return "pages/tongji/spf/zjxm";
    }
}
