package com.coob.zhfg.tj.domain;

import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 统计数据 - 商品房整体统计数据
 */
@Data
public class TjSpf implements Serializable {
    private static final long serialVersionUID = -1L;

    private Integer id;
    private Integer xms;        //项目数
    private Integer lzs;        //楼幢数

    private Integer zts;        //总套数
    private BigDecimal zmj;     //总面积
    private Integer ztsz;       //总套数-住宅
    private BigDecimal zmjz;    //总面积-住宅

    private Integer xsts;       //销售套数
    private BigDecimal xsmj;    //销售面积
    private Integer xstsz;      //销售套数-住宅
    private BigDecimal xsmjz;   //销售面积-住宅

    private Integer kcts;       //库存套数
    private BigDecimal kcmj;   //库存面积
    private Integer kctsz;       //库存套数-住宅
    private BigDecimal kcmjz;   //库存面积-住宅
    private BigDecimal yxsmj;   //月销售面积（最近12个月平均销售面积）
    private BigDecimal yxsmjz;   //月销售面积-住宅（最近12个月平均销售面积）
    private Integer qhzq;       //总库存去化周期
    private Integer qhzqz;      //住宅库存去化周期-住宅

    private Integer csnf;       // 农房村 数量
    private Integer ztsnf;      //农房村 总套数
    private BigDecimal zmjnf;   //农房村 总面积

    private String tjsj;        //统计时间

    public static final Integer ID_SPF = 1;     //商品房数据id
    public static final Integer ID_ZJXM = 2;    //在建在售项目id
}
