package com.coob.zhfg.tj.service;

import com.coob.aframe.util.DateUtil;
import com.coob.zhfg.tj.dao.TjSpfDao;
import com.coob.zhfg.tj.domain.TjSpf;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class TjSpfService {
    @Autowired
    private TjSpfDao tjSpfDao;


    /**
     * 保存商品房整体数据统计信息
     * @param tj
     * @return
     */
    public void saveSpf(TjSpf tj){
        tj.setId(TjSpf.ID_SPF);
        tj.setTjsj(DateUtil.getCurTime());

        TjSpf _tj = this.tjSpfDao.selectById(TjSpf.ID_SPF);
        if( _tj == null ) {
            this.tjSpfDao.insert(tj);
        } else {
            this.tjSpfDao.update(tj);
        }
    }

    /**
     * 保存在建在售项目统计数据
     * @param tj
     */
    public void saveZjxm(TjSpf tj){
        tj.setId(TjSpf.ID_ZJXM);
        tj.setTjsj(DateUtil.getCurTime());

        TjSpf _tj = this.tjSpfDao.selectById(TjSpf.ID_ZJXM);
        if( _tj == null ) {
            this.tjSpfDao.insert(tj);
        } else {
            this.tjSpfDao.update(tj);
        }
    }


    /**
     * 查询商品房整体统计数据
     * @return
     */
    public TjSpf selectSpfTj() {
        TjSpf tj = this.tjSpfDao.selectById(TjSpf.ID_SPF);
        return tj;
    }


    /**
     * 查询在建在售项目统计数据
     * @return
     */
    public TjSpf selectZjxmTj() {
        TjSpf tj = this.tjSpfDao.selectById(TjSpf.ID_ZJXM);
        return tj;
    }
}
